var bco56200_LancamentoDespesa_Controller = function(ScreenService, General, templateManager, contabilizacaoController){

    
    this.newLancDespCaixa = function (args) {
        var widget = templateManager.container.getWidget('LancamentoDespesasGrid');
        widget.newRow();
        
        widget.getField('CDCENTCUST').setValue('');
        widget.getField('NMCENTCUST').setValue('');
        widget.getField('NMCENTCUST').dataSourceFilter[0].value = '';
        widget.getField('NMCENTCUST').readOnly = true;
        widget.getField('NMCENTCUST').reload();
        
        templateManager.updateTemplate();
        
    };
    
    this.setDescLancDesp = function (args) {
        args.row.DSLANCDESP = args.row.NMDESPESA;
    };
    
    this.saveLancDespCaixa = function (args) {
        var widget = templateManager.container.getWidget('LancamentoDespesasGrid');
        
        if(widget.isValid()){
            
            if(widget.currentRow.VRLANCDESP <= 0){
                ScreenService.showMessage('Operação bloqueada. Valor deve ser maior que zero.');
                return;
            }
    
            General.callRestEngine('fin_movimentacaoBancaria#/saveLancDespCaixa', 'Row', widget.currentRow).then(function() {
                ScreenService.showMessage('Registros salvo com sucesso.');
                ScreenService.closeSwipe();
                
                widget.activate();
                widget.reload();
            }, function (error) {
                if (contabilizacaoController.checkErrosContabilizacao(error)) {
                    ScreenService.showMessage(error.data.error);
                }
            });
            
        }
    };
    
    this.deleteLancDespCaixa = function (args) {
        var widget = templateManager.container.getWidget('LancamentoDespesasGrid');
        
        ScreenService.confirmMessage('Deseja realmente excluir o registro?', 'question', function() {

            General.callRestEngine('fin_movimentacaoBancaria#/deleteLancDespCaixa', 'Row', widget.currentRow).then(function() {
                ScreenService.showMessage('Registros excluído com sucesso.');
                ScreenService.closeSwipe();
                
                widget.activate();
                widget.reload();
            });

        });
        
    };
    
    this.setCentCustFil = function (args) {
        var widget = templateManager.container.getWidget('LancamentoDespesasGrid');
        var value = '';
        var readOnly = true;
        
        var unidade = widget.getField('CDFILIAL').value();
        
        if(unidade){
            value = unidade;
            readOnly = false;
        }
        
        widget.getField('CDCENTCUST').setValue('');
        widget.getField('NMCENTCUST').setValue('');
        widget.getField('NMCENTCUST').dataSourceFilter[0].value = value;
        widget.getField('NMCENTCUST').readOnly = readOnly;
        widget.getField('NMCENTCUST').reload();
        
        templateManager.updateTemplate();
    };
    
};
/*global Configuration*/
Configuration(function (ContextRegister){
    ContextRegister.register('Bco56200_LancamentoDespesa_Controller', bco56200_LancamentoDespesa_Controller);
});